import { FN, PromiseValue, Methods, MethodsSerialized, Options, Task } from './types';
import Worker from './worker';
declare class WorkTank<MethodName extends string, MethodFunction extends FN> {
    terminated: boolean;
    name: string;
    size: number;
    methods: MethodsSerialized<MethodName> | string;
    tasksBusy: Set<Task<MethodName, MethodFunction>>;
    tasksReady: Set<Task<MethodName, MethodFunction>>;
    workersBusy: Set<Worker<MethodName, MethodFunction>>;
    workersReady: Set<Worker<MethodName, MethodFunction>>;
    constructor(options: Options<MethodName, MethodFunction>);
    _getMethodsSerialized(methods: Methods<MethodName, MethodFunction> | string): MethodsSerialized<MethodName> | string;
    _getTaskReady(): Task<MethodName, MethodFunction> | undefined;
    _getWorkerName(): string;
    _getWorkerReady(): Worker<MethodName, MethodFunction> | undefined;
    exec(method: MethodName, args: Parameters<Methods<MethodName, MethodFunction>[MethodName]>): Promise<PromiseValue<ReturnType<Methods<MethodName, MethodFunction>[MethodName]>>>;
    terminate(): void;
    tick(): void;
}
declare const _default: typeof WorkTank & {
    default: typeof WorkTank;
}
declare namespace _default {
    export type type = WorkTank;
}
export = _default;
