"use strict";
/* IMPORT */
Object.defineProperty(exports, "__esModule", { value: true });
const backend_compiled_1 = require("./backend_compiled");
const frontend_abstract_1 = require("./frontend_abstract");
/* WORKER WEB */
class WorkerWeb extends frontend_abstract_1.default {
    /* CONSTRUCTOR */
    constructor(listener, name) {
        super();
        this.workerBlob = new Blob([backend_compiled_1.default], { type: 'text/javascript' });
        this.workerBlobUrl = URL.createObjectURL(this.workerBlob);
        this.worker = new Worker(this.workerBlobUrl, { name });
        this.listen(listener);
    }
    /* API */
    listen(listener) {
        this.worker.addEventListener('message', event => listener(event.data));
    }
    terminate() {
        super.terminate();
        URL.revokeObjectURL(this.workerBlobUrl);
    }
}
/* EXPORT */
exports.default = WorkerWeb;
