import { FN, Message, MessageReady, MessageResult, MethodsSerialized, Task } from '../types';
import WorkerNode from './frontend_node';
import WorkerWeb from './frontend_web';
declare class Worker<MethodName extends string, MethodFunction extends FN> {
    busy: boolean;
    loaded: boolean;
    terminated: boolean;
    name: string;
    methods: MethodsSerialized<MethodName> | string;
    task?: Task<MethodName, MethodFunction>;
    worker: WorkerWeb | WorkerNode;
    constructor(methods: MethodsSerialized<MethodName> | string, name: string);
    onMessage(message: Message): void;
    onMessageReady(message: MessageReady): void;
    onMessageResult(message: MessageResult): void;
    init(): void;
    exec(task: Task<MethodName, MethodFunction>): void;
    terminate(): void;
    tick(): void;
}
export default Worker;
